import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.io.*;

public class DIO {
	tsctl ts;
	byte inst;

	public static final byte NetDIO_Lock=0;
	public static final byte NetDIO_Refresh=1;
	public static final byte NetDIO_Commit=2;
	public static final byte NetDIO_Set=3;
	public static final byte NetDIO_Get=4;
	public static final byte NetDIO_SetAsync=5;
	public static final byte NetDIO_GetAsync=6;
	public static final short NetDIOClass=5;

	public static final int TryLock=0;
	public static final int WaitLock=1;
	public static final int DoRelease=2;
	public static final int DoPreempt=5;

	public static final int LOW = 0;
	public static final int HIGH = 1;
	public static final int INPUT = -1;
	public static final int INPUT_LOW = -3;
	public static final int INPUT_HIGH = -2;

	int calls;
	public DIO(tsctl tss,byte instance) {
		ts = tss;
		inst = instance;
		calls=0;
	}
	public int Lock(int cmd,int num) throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(12);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_Lock);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		buf.putInt(cmd);
		buf.putInt(num);
		return ts.DoCmd(buf.array(), 4, true);
	}
	public int Refresh() throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(4);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_Refresh);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		return ts.DoCmd(buf.array(), 4, false);
	}
	public int Commit(int forceall) throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(8);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_Commit);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		buf.putInt(forceall);
		return ts.DoCmd(buf.array(), 4, false);
	}
	public int Set(int DIONum, int state) throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(12);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_Set);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		buf.putInt(DIONum);
		buf.putInt(state);
		return ts.DoCmd(buf.array(), 4, false);
	}
	public int Get(int DIONum) throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(8);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_Get);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		buf.putInt(DIONum);
		return ts.DoCmd(buf.array(), 4, true);
	}
	public int SetAsync(int DIONum, int state) throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(12);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_SetAsync);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		buf.putInt(DIONum);
		buf.putInt(state);
		return ts.DoCmd(buf.array(), 4, false);
	}
	public int GetAsync(int DIONum) throws IOException {
		ByteBuffer buf = ByteBuffer.allocate(8);
		buf.order(ByteOrder.BIG_ENDIAN);
		buf.put(NetDIO_GetAsync);
		buf.put(inst);
		buf.putShort(NetDIOClass);
		buf.putInt(DIONum);
		calls++;
		return ts.DoCmd(buf.array(), 4, true);
	}
}
