import java.net.Socket;
import java.io.*;

public class tsctl {
	Socket s;
	int mode;
	OutputStream o;
	InputStream i;
	byte q[];
	int cmds;

	public static final int NetModeBlocking=0;
	public static final int NetModeNonBlocking=1;
	public static final int NetModeQueued=2;

	public tsctl(String hostName,int blockingMode) throws IOException {
		s = new Socket(hostName,5001);
		mode = blockingMode;
		q = new byte[0];
		o = s.getOutputStream();
		i = s.getInputStream();
		cmds = 0;
	}
	protected void finalize() throws IOException {
		s.close();
	}
	public synchronized byte[] recv(int bytes) throws IOException {
		byte buffer[] = new byte[bytes];
		int n=0,x;
		while (n < bytes) {
			x = i.read(buffer,n,bytes-n);
			if (x > 0) {
				n += x;
			} else {
				return new byte[0];
			}
		}
		return buffer;
	}
	public synchronized int DoCmd(byte[] data,int bytes,boolean block) throws IOException {
		int tmp,n;
		byte buffer[];

		if (block || mode != NetModeQueued) {
			if (q.length > 0) {
				o.write(q);
				q = new byte[0];
				o.flush();
			} else {
				o.write(data);
				o.flush();
			}
			if (block || mode == NetModeBlocking) {
				if (cmds > 0) {
					tmp = 4 * cmds;
					buffer = new byte[tmp];
					while (tmp > 0) {
						n = i.read(buffer,0,tmp);
						if (n >= 0) {
							tmp -= n;
						} else {
							return -1;
						}
					}
					cmds = 0;
				}
				buffer = recv(bytes);
				if (bytes == 1) {
					return (int)buffer[0];
				} else if (bytes == 2) {
					return 256*(int)buffer[0] + buffer[1];
				} else { // bytes == 4
					return (buffer[0] << 24)+(buffer[1] << 16)+(buffer[2] << 8)+buffer[3];
				}
			} else {
				cmds++;
				return 1;
			}
		} else {
			// append data to q
			byte newq[] = new byte[q.length+data.length];
			System.arraycopy(q,0,newq,0,q.length);
			System.arraycopy(data,0,newq,q.length,data.length);
			q = newq;
			cmds++;
			return 1;
		}
	}
}
